using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using System.Threading;

namespace nxtBlueTooth
{
    public partial class Form1 : Form
    {
        private
        SerialPort BluetoothConnection= new SerialPort();
        public Form1()
        {
            InitializeComponent();
        }

        private void NXTSendCommandAndGetReply(byte[] Command)
        {
            Byte[] MessageLength= {0x00, 0x00};
            
            MessageLength[0]=(byte)Command.Length;
            this.textBox2.Text += "TX:";
            for (int i = 0; i < Command.Length; i++)
                this.textBox2.Text += Command[i].ToString("X2") + " ";
            this.textBox2.Text += Environment.NewLine;
            this.textBox2.Select(this.textBox2.Text.Length, 0);
            this.textBox2.ScrollToCaret();

            BluetoothConnection.Write(MessageLength, 0, MessageLength.Length);
            BluetoothConnection.Write(Command, 0, Command.Length);
            int length = BluetoothConnection.ReadByte() + 256 * BluetoothConnection.ReadByte();
            this.textBox2.Text += "RX:";
            for(int i=0;i<length ;i++)
                this.textBox2.Text += BluetoothConnection.ReadByte().ToString("X2") + " ";
            this.textBox2.Text += Environment.NewLine;
            this.textBox2.Select(this.textBox2.Text.Length, 0);
            this.textBox2.ScrollToCaret();
            }

        private void buttonConnect_Click(object sender, EventArgs e)
        {
            this.buttonConnect.Enabled = false;
            if (BluetoothConnection.IsOpen)
            {
                BluetoothConnection.Close();
                this.buttonConnect.Text = "Connect";
            }
            else
            {
                this.buttonConnect.Text = "Disconnect";
                this.BluetoothConnection.PortName = this.textBox1.Text.Trim();
                BluetoothConnection.Open();
                BluetoothConnection.ReadTimeout = 1500;

                this.buttonSendStr.Enabled = true;
                this.buttonIsMotorReady.Enabled = true;
            }
            this.buttonConnect.Enabled = true;

        }

        private void button1_Click(object sender, EventArgs e)
        {

        }

        private void button_clearlog_Click(object sender, EventArgs e)
        {
            this.textBox2.Text = "";
        }

        private void buttonIsMotorReady_Click(object sender, EventArgs e)
        {
            byte[] NxtMessage = { 0x00, 0x09, 0x00, (byte)3, 0x00, 0x00, 0x00};
            NxtMessage[2] = (byte)(this.numeric_MailboxWrite.Value);

            string tmp = this.textBox4.Text;

            for (int ByteCtr = 0; ByteCtr < 2; ByteCtr++)
            {
                NxtMessage[4 + ByteCtr] = (byte)tmp[ByteCtr];
                //tmp>>=8;
            }

            NXTSendCommandAndGetReply(NxtMessage);

            Thread.Sleep(int.Parse(textBox_WaitDur.Text));

            byte[] NxtReplyMessage = { 0x00, 0x13, 0x00, 0x00, 0x01 };
            NxtMessage[2] = (byte)(this.numeric_MailboxRead.Value);
            NXTSendCommandAndGetReply(NxtReplyMessage);
        }

        private void buttonSendStr_Click(object sender, EventArgs e)
        {
            byte[] NxtMessage = { 0x00, 0x09, 0x00, (byte)12, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
            NxtMessage[2] = (byte)(this.numeric_MailboxWrite.Value);
            string tmp = this.textBox3.Text;
            for (int ByteCtr = 0; ByteCtr < 11; ByteCtr++)
            {
                NxtMessage[4 + ByteCtr] = (byte)tmp[ByteCtr];
                //tmp>>=8;
            }
            NXTSendCommandAndGetReply(NxtMessage);
        }
    }
}